with Common; use Common;
package Controller is

   pragma Remote_Call_Interface;
   --  this pragma turns the subprograms in this unit
   --+ into RPC for which stubs (proxies) will be built
   --+ and copied to the caller's side

   --  this is a remote access-to-class-wide type
   --+ which will be used to construct dynamically bound
   --+ dispatching calls (all those that have a controlling
   --+ of a type in the derivation hierarchy of this type)
   type Pool_Access is access all Pool_Type'Class;

   pragma Asynchronous (Pool_Access);
   --  pragma Asynchronous is valid only in an RCI package
   --+ hence it cannot be applied to Test_Primarity in package
   --+ Common or Prime. Moreover, when we apply pragma Asynchronous
   --+ to Pool_Access, all subprograms dispatching on Pool_Type'Class
   --+ with only 'in' parameters become asynchronous RPCs

   --  this is a dynamically bound dispatching subprogram
   function Register
     (Pool : Pool_Access;
      PID  : Partition_ID)
      return Boolean;

   function  Next
     (PID : Partition_ID)
      return Pool_Access;

end Controller;
