with Ada.Text_IO;
with Controller;
with Results;
with Common;

--  "Main" is the only thread of control
--+ in the whole distributed application
procedure Main is
   use Common;
   use Ada.Text_IO;

   Divider : Natural;
   Where   : Common.Partition_ID;
   Starter : Controller.Pool_Access;

begin -- Main

   Starter := Controller.Next (Main'Partition_ID);

   for Number in 2 .. Common.Limit loop

      --  RPC directed to the partition identified by "Starter"
      Common.Test_Primarity (Starter, Number);

      --  blocking call to a protected entry
      --+ when open, it delivers the divider of "Number"
      --+ and the partition on which the divider was determined
      Results.Load_When_Ready (Divider, Where);

      if Divider = Number then
         Put_Line ("*** " & Natural'Image (Number) &
                   " (prime located by partition " &
                   Partition_ID'Image (Where) & ") ***");

         --  the else branch is way too verbose
         --+ so we comment it out
         --+--------------------------------

--        else
--           Put_Line (Natural'Image (Number) &
--                     "             (divided by" &
--                     Natural'Image (Divider) &
--                     " on partition " &
--                     Partition_ID'Image (Where) &
--                     ")");
      end if;
   end loop;

end Main;
